/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package tweets;

import java.net.MalformedURLException;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Locale;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import twitter4j.Paging;
import twitter4j.ResponseList;
import twitter4j.Status;
import twitter4j.Twitter;
import twitter4j.TwitterException;
import twitter4j.User;

/**
 *
 * @author Perla Maciel
 */
public class Tweets extends javax.swing.JFrame {

    static BD.MySqlConn mysql = new BD.MySqlConn();
    Twitter twitter;
    DefaultListModel statuses = new DefaultListModel();
    
    public Tweets(Twitter twitter) throws TwitterException, MalformedURLException {
        initComponents();
        this.twitter = twitter;
        setVisible(true);
        setTitle("Tweets");
        User usuario = twitter.showUser(twitter.getId());
        
        URL urlImg = new URL(usuario.getProfileImageURL());
        ImageIcon img = new ImageIcon(urlImg);
        UserIcon.setIcon(img);
    }

    //Metodo que extrae los tweets de un usuario dado
    public void actualizar (String usr) throws TwitterException {
       int pageno = 1,i=1;
        ResponseList<Status> listado;
        Status stat;
        //Cantidad de tweets esperados
        while (pageno<=40) {
          try {
            Paging page = new Paging(pageno++, 100);
            listado = twitter.getUserTimeline(usr, page);
            stat = listado.get(pageno);
            statuses.addElement(listado.get(2));
            stats(stat);
            i++;
          }catch(IndexOutOfBoundsException e) {
            //e.printStackTrace();
          }
        }
    }
    
    //Metodo para crear los dato para el query
    private void stats(Status s){
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String[] t = s.getText().split("'");
        StringBuilder builder = new StringBuilder();
        for(String ser : t) {
            builder.append(ser);
        }
        String str = builder.toString();
        String fecha_creacion=format.format(s.getCreatedAt());
        String id_tweet= Long.toString(s.getId());
        String text= str;
        String language=s.getLang();
        String retweet=Integer.toString(s.getRetweetCount());
        //String geolocation= Double.toString(s.getGeoLocation().getLatitude()) 
        //        +","+Double.toString(s.getGeoLocation().getLongitude());
        
        String name=s.getUser().getName();
        String user_id=Long.toString(s.getUser().getId());
        guardar(id_tweet,text,fecha_creacion,language,retweet,"null",name,user_id);
    }
    
    //Metodo para generar el query y hacer la insercion a las base de datos
    private static void guardar (String id_tweet, String text, String fecha_creacion, String language, String retweet, String geolocation, String name, String user_id){
        String query = "";
        query = "insert into Tweet (tweet_id,content_text,creation_date,language,retweet,geolocation,user_name,user_id) values ("+
                "'" + id_tweet + "'," +
                "'" + text + "'," +
                "'" + fecha_creacion + "'," +
                "'" + language + "'," +
                "'" + retweet + "'," +
                "'" + geolocation + "'," +
                "'" + name + "'," +
                "'" + user_id + "')";
        System.out.println(query);
        mysql.Update(query);
        
    } 
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        UserIcon = new javax.swing.JLabel();
        Actualizar = new javax.swing.JButton();
        Source = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        tweets = new javax.swing.JList<String>();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        UserIcon.setBackground(new java.awt.Color(0, 0, 0));
        UserIcon.setMaximumSize(new java.awt.Dimension(48, 48));

        Actualizar.setText("Actualizar");
        Actualizar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ActualizarActionPerformed(evt);
            }
        });

        tweets.setModel(statuses);
        tweets.setCellRenderer(new Panel_Tweets(twitter)
        );
        jScrollPane1.setViewportView(tweets);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(22, 22, 22)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 763, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(24, 24, 24)
                        .addComponent(UserIcon, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(Source)
                        .addGap(18, 18, 18)
                        .addComponent(Actualizar)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(18, 18, 18)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 208, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(Actualizar)
                            .addComponent(Source, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(7, 7, 7)
                        .addComponent(UserIcon, javax.swing.GroupLayout.PREFERRED_SIZE, 49, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(28, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void ActualizarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ActualizarActionPerformed
        // TODO add your handling code here:
        if (Source.getText().equals("") == false){
            try {
                actualizar(Source.getText());
            } catch (TwitterException ex) {
                Logger.getLogger(Tweets.class.getName()).log(Level.SEVERE, null, ex);
            }
        }else{
           
            try {
                Status tweet = twitter.updateStatus(Source.getText());
                Source.setText("");
            } catch (TwitterException ex) {
                Logger.getLogger(Tweets.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }//GEN-LAST:event_ActualizarActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Tweets.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Tweets.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Tweets.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Tweets.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                //new Tweets().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton Actualizar;
    private javax.swing.JTextField Source;
    private javax.swing.JLabel UserIcon;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JList<String> tweets;
    // End of variables declaration//GEN-END:variables
}
